
class Matrix {

  var m:Array;

  // Constructor
  function Matrix() {
    m    = new Array( 4 );
    m[0] = new Array(1,0,0,0);
    m[1] = new Array(0,1,0,0);
    m[2] = new Array(0,0,1,0);
    m[3] = new Array(0,0,0,1);    
  }

  function copy():Matrix {
    var r:Matrix = new Matrix;
    for( var i=0; i<4; i++ )
     for( var j=0; j<4; j++ )
        r.m[i][j] = m[i][j];
    return r;
  }


  // Methods
  function info():String {
    return( "M: " + m[0] + "\n   " 
                  + m[1] + "\n   " 
                  + m[2] + "\n   " 
                  + m[3] );
  }


  function multR( r:Matrix ) {
    var t:Matrix = this.copy();
    for( var i=0; i<4; i++ )
     for( var j=0; j<4; j++ ) {
       m[i][j] = 0;
       for( var k=0; k<4; k++ )
         m[i][j] += t.m[i][k] * r.m[k][j];
     }

  }



  function rotation( i:Number, j:Number, a:Number ) {
    var c = Math.cos( a );
    var s = Math.sin( a );
    m[i][i] = c;
    m[i][j] =-s;
    m[j][i] = s;
    m[j][j] = c;
  }

}